using System;
using UnityEngine;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using SimpleJSON;
using System.Linq;
using MVR;
using MeshVR;
using MVR.FileManagementSecure;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;
using GPUTools.Cloth.Scripts;
using Unity.Collections;
using System.Diagnostics;

namespace Stopper {
	public class ControlledBJ : MVRScript {
		
		// Female
		DAZMergedSkinV2 skin;
		Vector3[] femaleSkinGPUVertices;
		ComputeBuffer femaleSkinGPUBuffer;
		FreeControllerV3 upperTeethController;
		
		Atom upperTeethHandle;
		Rigidbody upperTeethHandleRB;
		
		Vector3 uppderTeethVector;
		
		Rigidbody headRB;
		FreeControllerV3 headController;
		ConfigurableJoint upperTeethJoint;
		JointDrive upperTeethJointDrive;
		
		DAZMorph mouthOpenWide;
		
		// Male 
		Atom male;
		Rigidbody gen1, gen2, gen3;
		
		Collider mPenisGen1, mPenisGen2, mPenisGen3a, mPenisGen3b;
		List<Collider> mPenisColliders = new List<Collider>();

		// UI
		JSONStorableString debug;
		GameObject penisTipMarker;
		
		
		List<UnityEngine.Object> createdObjects = new List<UnityEngine.Object>();
		
		bool ready = false;
		
		// Bezier Curves
		GameObject mainContainer;
		CubicBezierCurve centralCurve;
		
		CubicBezierCurve upperTeethCurve;
		ControllableBezierCurvePoint utp1,utp2,utp3,utp4,utp5,utp6,utp7; 
		List<ControllableBezierCurvePoint> upperTeethCurvePoints = new List<ControllableBezierCurvePoint>();
		
		float previousClosestCurvePosition=0f;
		
		// Configurables
		JSONStorableFloat penisTipLength;
		JSONStorableFloat minMouthTopOffset;
		
		JSONStorableFloat mouthOpenMin;
		JSONStorableFloat mouthOpenMax;
		
		JSONStorableFloat mouthOpenStartDistance;
		JSONStorableFloat mouthOpenCurve;
		
		JSONStorableFloat outerInteractionDistance;
		JSONStorableFloat interactionDistance;
		JSONStorableFloat interactionCurve;
		
		JSONStorableFloat movementSpeed;
		JSONStorableFloat maxForce;
		
		JSONStorableStringChooser maleSelection;
		
		public class ControllableBezierCurvePoint {
			public GameObject sphere;
			public CubicBezierPoint bezierPoint;
			public JSONStorableFloat position;
			public JSONStorableFloat distance;
		}
		
		public override void Init() {
			
			//for(int i=1;i<=31;i++) //user defined layers start with layer 8 and unity supports 31 layers
			//{
			//	SuperController.LogMessage($"Layer: {i} {LayerMask.LayerToName(i)} " );
			//}
			
			mainContainer = new GameObject("ControlledBJ");
			createdObjects.Add(mainContainer);
			mainContainer.transform.parent = containingAtom.transform;
			mainContainer.SetActive(true);
			
			skin = containingAtom.GetComponentInChildren<DAZMergedSkinV2>();
			
			femaleSkinGPUBuffer = skin.rawVertsBuffer;
			femaleSkinGPUVertices = new Vector3[femaleSkinGPUBuffer.count];
			
			headRB = containingAtom.rigidbodies.First(rb => rb.name == "head");
			headController = containingAtom.freeControllers.First(c => c.name == "headControl");
			
			penisTipMarker = CreateSphere(Color.blue);
			penisTipMarker.GetComponent<MeshRenderer>().enabled = false;
			penisTipMarker.SetActive(true);
			
			
		
			// Morphs
			var characterSelector = containingAtom.GetComponentInChildren<DAZCharacterSelector>();
			var morphControl = characterSelector.morphsControlUI;				
			mouthOpenWide = morphControl.GetMorphByDisplayName("Mouth Open Wide");
			
			
			// UI
			debug = new JSONStorableString("debug", "");
			
			/*
			RegisterString(debug);
			var debugTextField = CreateTextField(debug, true);
			debugTextField.height = 150;
			*/
			
			maleSelection = new JSONStorableStringChooser("MaleAtom", GetMales(), null, "Male Atom", (string maleUid) => {
				ConfigureMale(maleUid);
			});
			
			if(GetMales().Count == 1){
				maleSelection.val = GetMales().First();
			}
			
			RegisterStringChooser(maleSelection);
			var popup = CreateScrollablePopup(maleSelection, false);
			popup.popup.onOpenPopupHandlers += () => {
				maleSelection.choices = GetMales();
			};
			
			var penisTipLengthSliderUI = AddSlider("Penis Tip Length", 0.050f, 0f, 0.1f);
			penisTipLengthSliderUI.valueFormat = "F3";
			penisTipLength = sliderToJSONStorableFloat[penisTipLengthSliderUI];
						
			var mouthOpenMaxSliderUI = AddSlider("Mouth Open Max", 1f, 0f, 2f);
			mouthOpenMaxSliderUI.valueFormat = "F2";
			mouthOpenMax = sliderToJSONStorableFloat[mouthOpenMaxSliderUI];
			
			var mouthOpenMinSliderUI = AddSlider("Mouth Open Min", 0f, 0f, 2f);
			mouthOpenMinSliderUI.valueFormat = "F2";
			mouthOpenMin = sliderToJSONStorableFloat[mouthOpenMinSliderUI];
			
			var mouthOpenStartDistanceSliderUI = AddSlider("Mouth Open Start Distance", 0.2f, 0f, 1f);
			mouthOpenStartDistanceSliderUI.valueFormat = "F2";
			mouthOpenStartDistance = sliderToJSONStorableFloat[mouthOpenStartDistanceSliderUI];
			
			var mouthOpenCurveSliderUI = AddSlider("Mouth Open Curve", 3f, 0.1f, 10f);
			mouthOpenCurveSliderUI.valueFormat = "F2";
			mouthOpenCurve = sliderToJSONStorableFloat[mouthOpenCurveSliderUI];
						
			var interactionDistanceSliderUI = AddSlider("Inner Interaction Distance", 0.03f, 0f, 0.2f);
			interactionDistanceSliderUI.valueFormat = "F3";
			interactionDistance = sliderToJSONStorableFloat[interactionDistanceSliderUI];
			
			var outerInteractionDistanceSliderUI = AddSlider("Outer Interaction Distance", 0.05f, 0f, 1f);
			outerInteractionDistanceSliderUI.valueFormat = "F3";
			outerInteractionDistance = sliderToJSONStorableFloat[outerInteractionDistanceSliderUI];
			
			var interactionCurveSliderUI = AddSlider("Interaction Curve", 5f, 0.1f, 10f);
			interactionCurveSliderUI.valueFormat = "F2";
			interactionCurve = sliderToJSONStorableFloat[interactionCurveSliderUI];
			
			var movementSpeedSliderUI = AddSlider("Movement Speed", 10f, 1f, 50f);
			movementSpeed = sliderToJSONStorableFloat[movementSpeedSliderUI];
			
			var maxForceSliderUI = AddSlider("Max Force", 100000f, 0f, 100000f);
			maxForce = sliderToJSONStorableFloat[maxForceSliderUI];
						
			//var minMouthTopOffsetUI = AddSlider("Min Mouth Top Offset", 0.00f, 0f, 0.1f);
			//minMouthTopOffsetUI.valueFormat = "F3";
			//minMouthTopOffset = sliderToJSONStorableFloat[minMouthTopOffsetUI];
			
			var penisTipMarkerToggle = CreateToggle(new JSONStorableBool("Show Penis Tip Marker (Blue)", false), true);
			penisTipMarkerToggle.toggle.onValueChanged.AddListener((val) => {
				penisTipMarker.GetComponent<MeshRenderer>().enabled = val;
			});
			
			var upperTeethCurveVisToggle = CreateToggle(new JSONStorableBool("Show Upper Jaw Path", false), true);
			upperTeethCurveVisToggle.toggle.onValueChanged.AddListener((val) => {
				foreach(var point in upperTeethCurvePoints){
					point.sphere.GetComponent<MeshRenderer>().enabled = val;
				}
				upperTeethCurve.draw = val;
			});
		}
		
		private void CreateCentralCurve(){
			centralCurve = mainContainer.AddComponent<CubicBezierCurve>();
			centralCurve.enabled = true;
			centralCurve.loop = false;
			centralCurve.material = new Material("Standard");
			
			var pointList = new List<CubicBezierPoint>();
			
			CreateBezierPoint(gen1.transform, pointList);
			CreateBezierPoint(gen2.transform, pointList);
			CreateBezierPoint(gen3.transform, pointList);
			CreateBezierPoint(penisTipMarker.transform, pointList, 0.03f);
			CreateBezierPoint(headRB.transform, pointList, -0.01f);
			
			centralCurve.points = pointList.ToArray();
			centralCurve.curveType = CubicBezierCurve.CurveType.Disjoint;
			centralCurve.draw = false;
		}
		
		private void CreateUpperCurve(){
			
			upperTeethCurve = mainContainer.AddComponent<CubicBezierCurve>();
			upperTeethCurve.enabled = true;
			upperTeethCurve.loop = false;
			upperTeethCurve.material = new Material("Standard");
			
			var pointList = new List<CubicBezierPoint>();
			
			utp1 = CreateControllableBezierCurvePoint("Gen1", false, true, gen1.transform, pointList, Color.green);
			utp2 = CreateControllableBezierCurvePoint("Gen2", true, true, gen2.transform, pointList, Color.green);
			utp3 = CreateControllableBezierCurvePoint("Gen3a", true, true, gen3.transform, pointList, Color.green);
			utp4 = CreateControllableBezierCurvePoint("Gen3b", true, true, gen3.transform, pointList, Color.green, 0.025f, 0.02f);
			utp5 = CreateControllableBezierCurvePoint("Tip", true, true, penisTipMarker.transform, pointList, Color.green, 0.006f, 0f, 0.005f);
			//utp6 = CreateControllableBezierCurvePoint("Approach", true, true, penisTipMarker.transform, pointList, Color.red, 0f, 0.03f);
			utp7 = CreateControllableBezierCurvePoint("Head", false, false, headRB.transform, pointList, Color.green);
			
			//utp5.bezierPoint.controlPointOut.transform.localPosition = new Vector3(0f,0f,0.03f);
			
			utp7.bezierPoint.controlPointIn.transform.localPosition = new Vector3(0f,0f,0.1f);
			
			
			upperTeethCurvePoints.Add(utp1);
			upperTeethCurvePoints.Add(utp2);
			upperTeethCurvePoints.Add(utp3);
			upperTeethCurvePoints.Add(utp4);
			upperTeethCurvePoints.Add(utp5);
			//upperTeethCurvePoints.Add(utp6);
			//upperTeethCurvePoints.Add(utp7);
			
			
			upperTeethCurve.points = pointList.ToArray();
			upperTeethCurve.curveType = CubicBezierCurve.CurveType.Disjoint;
			upperTeethCurve.draw = false;
		}
		
		private CubicBezierPoint CreateBezierPoint(Transform t, List<CubicBezierPoint> pointList, float f = 0.1f){
			var point = mainContainer.AddComponent<CubicBezierPoint>();
			point.point = t;
			
			var bzpInContainer = new GameObject();
			bzpInContainer.transform.parent = t;
			createdObjects.Add(bzpInContainer);
			point.controlPointIn = bzpInContainer.AddComponent<CubicBezierControlPoint>();
			
			var bzpOutContainer = new GameObject();
			bzpOutContainer.transform.parent = t;
			createdObjects.Add(bzpOutContainer);
			point.controlPointOut = bzpOutContainer.AddComponent<CubicBezierControlPoint>();
			
			point.controlPointIn.transform.localPosition = new Vector3(0f,0f,-f);
			point.controlPointOut.transform.localPosition = new Vector3(0f,0f,f);
			pointList.Add(point);
			return point;
		}
		
		private ControllableBezierCurvePoint CreateControllableBezierCurvePoint(string displayName, bool positionMutable, bool distanceModifiable, Transform parent, List<CubicBezierPoint> pointList, Color color, float distance = 0.028f, float position = 0f, float curve = 0.01f){
			ControllableBezierCurvePoint cbcp = new ControllableBezierCurvePoint();
			
			
			cbcp.sphere = CreateSphere(color);
			cbcp.sphere.transform.parent = parent;
			cbcp.sphere.transform.localPosition = new Vector3(0f,0f,position);
			cbcp.sphere.transform.rotation = parent.rotation;
			cbcp.sphere.GetComponent<MeshRenderer>().enabled = false;
			
			cbcp.bezierPoint = CreateBezierPoint(cbcp.sphere.transform, pointList, curve );
			
			if(distanceModifiable){
				var pointDistanceUI = AddSlider($"{displayName} Distance", distance, 0f, 0.1f, null, true);
				pointDistanceUI.valueFormat = "F3";
				cbcp.distance = sliderToJSONStorableFloat[pointDistanceUI];
			} else {
				cbcp.distance = new JSONStorableFloat($"{displayName} Distance", distance, distance, distance, true, true);
				RegisterFloat(cbcp.distance);
			}
			
			if(positionMutable){
				var pointPositionUI = AddSlider($"{displayName} Position", position, 0f, 0.1f, null, true);
				pointPositionUI.valueFormat = "F3";
				cbcp.position = sliderToJSONStorableFloat[pointPositionUI];
			} else {
				cbcp.position = new JSONStorableFloat($"{displayName} Position", position, position, position, true, true);
				RegisterFloat(cbcp.position);
			}
			
			return cbcp;
		}
		
		private void Start(){
			StartCoroutine("CreateUpperTeethHandle");
		}
		
		
		private IEnumerator CreateUpperTeethHandle(){
			string upperTeethHandleUid = $"{containingAtom.uid}#upperTeethHandle";
			
			upperTeethHandle = SuperController.singleton.GetAtomByUid(upperTeethHandleUid);
			if(upperTeethHandle == null){
				yield return SuperController.singleton.AddAtomByType("Empty", upperTeethHandleUid);
				upperTeethHandle = SuperController.singleton.GetAtomByUid(upperTeethHandleUid);
			}	
			
			upperTeethHandle.hidden = true;
			
		}
		
		private void LateUpdate(){
			if(ready || upperTeethHandle == null || femaleSkinGPUBuffer == null){
				return;
			}
			
			femaleSkinGPUBuffer.GetData(femaleSkinGPUVertices,0,0,femaleSkinGPUBuffer.count);
			
			upperTeethHandle.transform.position = femaleSkinGPUVertices[15700];
			upperTeethHandle.transform.rotation = headRB.transform.rotation;
			
			upperTeethHandleRB = upperTeethHandle.GetComponentInChildren<Rigidbody>();
			upperTeethController = upperTeethHandle.GetComponentInChildren<FreeControllerV3>();
			
			uppderTeethVector = Quaternion.Inverse(headRB.transform.rotation) * (upperTeethHandle.transform.position - headRB.transform.position);
			
			upperTeethJoint = headRB.gameObject.AddComponent<ConfigurableJoint>();
			upperTeethJoint.connectedBody = upperTeethHandleRB;
			upperTeethJoint.autoConfigureConnectedAnchor = false;
			upperTeethJoint.anchor = Quaternion.Inverse(headRB.transform.rotation) * (upperTeethHandle.transform.position - headRB.transform.position);
			upperTeethJoint.connectedAnchor = Vector3.zero;
			
			upperTeethJointDrive = new JointDrive();
			upperTeethJointDrive.maximumForce = 0f;
			upperTeethJointDrive.positionSpring = 0f;
			upperTeethJointDrive.positionDamper = 0f;
			
			upperTeethJoint.angularXMotion = ConfigurableJointMotion.Free;
			upperTeethJoint.angularYMotion = ConfigurableJointMotion.Free;
			upperTeethJoint.angularZMotion = ConfigurableJointMotion.Free;
			
			upperTeethJoint.xDrive = upperTeethJointDrive;
			upperTeethJoint.yDrive = upperTeethJointDrive;
			upperTeethJoint.zDrive = upperTeethJointDrive;
			
		//	CreateCentralCurve();
			CreateUpperCurve();
			ready = true;
		}
		
		private void Update(){
			if(!ready || male == null){
				return;
			}
			try{
			debug.val = "";
			
			float dTime = Time.fixedDeltaTime;
			
			Vector3 penisBase = gen1.transform.position;
			Vector3 penisMid = gen2.transform.position;
			
			penisTipMarker.transform.localPosition = new Vector3(0f,0f,penisTipLength.val);
			Vector3 penisTip = penisTipMarker.transform.position;
			
			float penisLength = (penisTip - penisBase).magnitude;
			
			foreach(var point in upperTeethCurvePoints){
				// Project the head's up vector onto the curve's normal
				var normal = point.sphere.transform.forward;
				Vector3 offset = (	headRB.transform.up - Vector3.Dot(headRB.transform.up, normal) / Vector3.Dot(normal, normal) * normal) * point.distance.val;
				
				// Transform into the curve's local coordinates
				offset = Quaternion.Inverse(point.sphere.transform.rotation) * offset ;
				offset.z = point.position.val;
				
				point.sphere.transform.localPosition = offset;
			}
			
			float progressDownShaft = 1f - ((upperTeethHandleRB.transform.position-penisBase).magnitude / penisLength);
			
			//debug.val += $"progressDownShaft {progressDownShaft} \n";
			
			Vector3 nearestPointOnShaft;
			
			int closestCurveIndex;
			float closestCurveT;
			
			Vector3 headMove = (headController.transform.position - headRB.transform.position) * 0.8f;
			
			float distanceLimit = previousClosestCurvePosition == 0f ? 10f : 0.3f; 
			nearestPointOnShaft = NearestPointOnBezierCurve(upperTeethCurve, headRB.transform.position+headRB.transform.rotation*uppderTeethVector+headMove, previousClosestCurvePosition, distanceLimit, out closestCurveIndex, out closestCurveT);
			
			previousClosestCurvePosition = closestCurveIndex + closestCurveT;
			
			//float distanceToNearestPoint = (upperTeethHandleRB.transform.position-nearestPointOnShaft).magnitude;
			
			float mouthOpen = mouthOpenMax.val;
			if(progressDownShaft < 0.2f){
				double mouthOpenPercent = (progressDownShaft + mouthOpenStartDistance.val)/(mouthOpenStartDistance.val + 0.2f);
				if(mouthOpenPercent > 0d)
					mouthOpenPercent = Math.Pow(mouthOpenPercent, 1d/(double)mouthOpenCurve.val);
				mouthOpen = Mathf.Lerp(mouthOpenMin.val, mouthOpen, (float)mouthOpenPercent);
			}
			
			//debug.val += $"mouthOpen {mouthOpen} \n";
			
			Vector3 upperLipTarget = nearestPointOnShaft ;
			
			//upperLipTarget += shaftVectorAtNearestPoint.normalized * headMovement;
				
			//s2.transform.position = upperLipTarget;
			//debug.val += $"distanceToNearestPoint {distanceToNearestPoint} \n";
			
			float distanceToNearestPoint = 0f;
			if(closestCurveIndex >= 4){
				distanceToNearestPoint = (upperTeethHandleRB.transform.position-penisTipMarker.transform.position).magnitude;
			}
			debug.val += $"distanceToNearestPoint {distanceToNearestPoint} \n";
			if(distanceToNearestPoint > interactionDistance.val){
				float outerDistance = Math.Max(outerInteractionDistance.val, interactionDistance.val);
				double strengthPercent = (distanceToNearestPoint - interactionDistance.val)/(outerDistance);
				if(strengthPercent > 0f){
					strengthPercent = Math.Pow(strengthPercent, 1d/(double)interactionCurve.val);
				}
				float strength = Mathf.Lerp(maxForce.val, 0f, (float)strengthPercent);
				upperTeethJointDrive.maximumForce = strength;
				upperTeethJointDrive.positionSpring = strength;
				//debug.val += $"strength {strength} \n";
			} else {
				upperTeethJointDrive.maximumForce = maxForce.val;
				upperTeethJointDrive.positionSpring = maxForce.val;
			}
			
			upperTeethJoint.xDrive = upperTeethJointDrive;
			upperTeethJoint.yDrive = upperTeethJointDrive;
			upperTeethJoint.zDrive = upperTeethJointDrive;
			
			
			
			upperTeethController.transform.rotation = headRB.transform.rotation;
			upperTeethController.transform.position += (upperLipTarget - upperTeethController.transform.position) * dTime * movementSpeed.val;
			
			
			// Morphs
			if(mouthOpenWide.morphValue != mouthOpen)
				mouthOpenWide.morphValue = mouthOpen;
			
			} catch (Exception e) {
				SuperController.LogMessage($"Update Exception {e}");
			}
		}
		
		private List<string> GetMales() {
			return SuperController.singleton.GetAtoms().Where(a => a.category == "People" && a.GetComponentInChildren<DAZCharacter>() != null && a.GetComponentInChildren<DAZCharacter>().isMale).Select(a => a.uid).ToList();
		}
		
		
		private void ConfigureMale(string uid)
		{
			male = SuperController.singleton.GetAtomByUid(uid);				
			
			gen1 = male.rigidbodies.First(rb => rb.name == "Gen1");
			gen2 = male.rigidbodies.First(rb => rb.name == "Gen2");
			gen3 = male.rigidbodies.First(rb => rb.name == "Gen3");
			
			penisTipMarker.transform.parent = gen3.transform;
			penisTipMarker.transform.rotation = gen3.transform.rotation;
		}
		
		private void OnDisable(){
			upperTeethJointDrive.maximumForce = 0f;
			upperTeethJointDrive.positionSpring = 0f;
			
			upperTeethJoint.xDrive = upperTeethJointDrive;
			upperTeethJoint.yDrive = upperTeethJointDrive;
			upperTeethJoint.zDrive = upperTeethJointDrive;
		}
		
		private void OnDestroy(){
			if(upperTeethHandle != null){
				SuperController.singleton.RemoveAtom(upperTeethHandle);
			}
			
			if(upperTeethJoint != null){
				UnityEngine.Object.Destroy(upperTeethJoint);
			}
			
			foreach(var obj in createdObjects){
				UnityEngine.Object.Destroy(obj);
			}
		}
		
		private UIDynamicSlider AddSlider(string name, float defaultVal, float min, float max, UnityAction<float> onChange = null, bool rightSide = false)
		{
			JSONStorableFloat storableFloat = new JSONStorableFloat(name, defaultVal, min, max, true, true);
			storableFloat.storeType = JSONStorableParam.StoreType.Full;
			UIDynamicSlider uiSlider = this.CreateSlider(storableFloat, rightSide);
			uiSlider.rangeAdjustEnabled = true;
			RegisterFloat(storableFloat);
			
			if(onChange != null){
				uiSlider.slider.onValueChanged.AddListener(onChange);
			}
			
			return uiSlider;
		}
		
		private GameObject CreateSphere(Color color){
			var sphere = GameObject.CreatePrimitive(PrimitiveType.Sphere);
			//sphere.transform.parent = mainContainer.transform;
			//sphere.layer = 30;
			
			
			SphereCollider collider = sphere.GetComponent<SphereCollider>();
			UnityEngine.Object.DestroyImmediate(collider);
			
			MeshFilter meshFilter = sphere.GetComponent<MeshFilter>();
			Mesh mesh = meshFilter.mesh;
			var vertices = mesh.vertices;
			for(int i = 0; i < mesh.vertices.Length; i++){
				vertices[i] = vertices[i] * 0.005f;
			}
			mesh.vertices = vertices;
			
			sphere.transform.localPosition = new Vector3(0f,0f,0f);
			
			
			sphere.GetComponent<Renderer>().material.color = color;
			
			
			createdObjects.Add(sphere);
			
			return sphere;
		}
		
		public static Vector3 NearestPointOnFiniteLine(Vector3 start, Vector3 end, Vector3 pnt, bool clampStart, bool clampEnd) {
			var line = (end - start);
			var len = line.magnitude;
			line.Normalize();
		   
			var v = pnt - start;
			var d = Vector3.Dot(v, line);
			
			if(clampEnd && d > len) {
				d = len;
			}
			
			if(clampStart && d < 0.0f) {
				d = 0.0f;
			}
			
			return start + line * d;
		}
		
		public Vector3 NearestPointOnBezierCurve(CubicBezierCurve curve, Vector3 pnt, float previousClosestPosition, float distanceLimit, out int closestSegment, out float closestT) {
			
			float closestDistSquared = 1000f;
			closestSegment = 0;
			closestT = 0f;
			Vector3 pointOnCurve = Vector3.zero;
			Vector3 closestPoint = Vector3.zero;
			
			for(int i = 0; i < curve.points.Length; i++){
				for(float t = 0f; t <= 1f; t += 0.1f){
					pointOnCurve = curve.GetPositionFromPoint(i, t);
					float distSquared = (pnt-pointOnCurve).sqrMagnitude;
					float position = i + t;
					if(distSquared < closestDistSquared && Math.Abs(previousClosestPosition - position) < distanceLimit){
						closestSegment = i;
						closestT = t;
						closestDistSquared = distSquared;
						closestPoint = pointOnCurve;
					}
				}
			}
			
			for(float r = 0.1f; r > 0.001f; r *=0.1f){
				for(float t = Math.Max(closestT-r, 0f); t < Math.Min(closestT+r, 1f); t += r/5f){
					pointOnCurve = curve.GetPositionFromPoint(closestSegment, t);
					float distSquared = (pnt-pointOnCurve).sqrMagnitude;
					if(distSquared < closestDistSquared){
						closestT = t;
						closestDistSquared = distSquared;
						closestPoint = pointOnCurve;
					}
				}
			}
			
			return closestPoint;
		}
	}
}